<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              http://lukealford.me
 * @since             1.0.0
 * @package           Codflask_Wp
 *
 * @wordpress-plugin
 * Plugin Name:       Flask Micro code-editor
 * Plugin URI:        http://lukealford.me
 * Description:       Shortcode implementation of Codeflask credit to <a href="https://twitter.com/kazzkiq">@kazzkiq</a> for the original <a href="https://kazzkiq.github.io/CodeFlask.js/">Codeflask</a>
 * Version:           1.0.0
 * Author:            Luke Alford
 * Author URI:        http://lukealford.me
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       codflask-wp
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

//setup shortcode
class codeflask {

	static function init() {

		add_shortcode('codeflask', array(__CLASS__, 'handle_shortcode'));

	}

	static function handle_shortcode($atts, $content = null) {

		//setup attributes
		extract(shortcode_atts(array(
			'title' => null,
      'language' => array(
					'markup',
					'html',
					'CSS',
					'c-like',
					'javascript',
					'abap',
					'actionscipt',
					'apache-configuration',
					'apl',
				 	'applescript',
					'asp',
					'autoit',
					'autohotkey',
					'bash',
					'basic',
					'batch',
					'bison',
					'brainfuck',
					'c',
					'c#',
					'c++',
					'coffeescript',
					'crystal',
					// prism.js supports a ton I don't need to list them all.... since it should grab waht ever you select in the shortcode attribute
				)
   ), $atts));

	 	ob_start();
		// actual shortcode handling here
		 echo "<div class='code-window'>";
		 echo "<header class='code-header'>" ;
     echo "<div class='code-buttons'></div>";
     echo "$atts[title]";
     echo "</header>";
		 echo "<div class='code-wrappers' data-language='$atts[language]'>";
		 echo "$content";
		 echo '</div>' ;
		 echo '</div>' ;
		 $output = ob_get_clean();


		 wp_enqueue_script('prisim-script', plugins_url('/includes/js/prism.js', __FILE__), '1.0', true);
		 wp_enqueue_script('cf-script', plugins_url('/includes/js/codeflask.js', __FILE__), '1.0', true);

		 //setup styles
		 wp_enqueue_style('prisim-style', plugins_url('/includes/css/prism.css', __FILE__), '1.0', true);
		 wp_enqueue_style('cf-style', plugins_url('/includes/css/codeflask.css', __FILE__), '1.0', true);
		 wp_enqueue_style('cf-css', plugins_url('/includes/css/app.css', __FILE__), '1.0', true);


		 //custom scripts
		 wp_register_script('cf-app', plugins_url('/includes/js/app.js', __FILE__), array('jquery'), '1.0', true);
		 wp_localize_script( 'cf-app', 'codeflask', $atts );
		 wp_enqueue_script( 'cf-app' );

		 return $output;

	}
}

codeflask::init();
